# AutoRest Documentation

1. Introduction
    - Get an [introduction][introduction] to the fundamental concepts of AutoRest

2. Installing AutoRest
    - You can [install AutoRest][install] on Windows, Mac, or Linux.

3. Defining Clients with OpenAPI
    - Learn [how to define your REST API][openapi] with OpenAPI

4. Generating Clients with AutoRest
    - How do I generate code? See [here][generate]

5. Using Your Generated Client
    - How do I [use my client][client] now that I've generated it?

6. Migrating from AutoRest 2.0 to 3.0
    - I have old generated code using the previous version of AutoRest. How do I [upgrade][migrate] my generation and use my new code?

7. Developing with AutoRest
    - How do I generate or contribute to AutoRest in [dev mode][dev]?

8. `Powershell` documentation
    - [How][powershell] do I use AutoRest to build `Powershell` cmdlets?

9. [FAQ][faq]

10. [Troubleshooting][troubleshooting]

<!-- LINKS -->
[introduction]: ./introduction.md
[install]: ./install/readme.md
[openapi]: ./openapi/readme.md
[generate]: ./generate/readme.md
[client]: ./client/readme.md
[migrate]: ./migrate/readme.md
[dev]: ./developer/readme.md
[powershell]: ./powershell/readme.md
[faq]: ./faq.md
[troubleshooting]: ./troubleshooting.md